<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/base/icecap-component-config/types/src/icecap.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>icecap.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../icecap_component_config_types/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../icecap_component_config_types/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../icecap_component_config_types/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">sel4::prelude</span>::<span class="kw-2">*</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::ConfigCPtr</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">icecap_runtime::LowLevelStaticThread</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">icecap_threading::StaticThread</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">sel4</span>::{<span class="ident">local_cptr</span>::<span class="kw-2">*</span>, <span class="ident">Badge</span>, <span class="ident">CPtr</span>, <span class="ident">CPtrBits</span>};

<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">WrappedCPtr</span> {
    <span class="kw">fn</span> <span class="ident">wrap</span>(<span class="ident">bits</span>: <span class="ident">CPtrBits</span>) -&gt; <span class="self">Self</span>;
}

<span class="kw">impl</span> <span class="ident">WrappedCPtr</span> <span class="kw">for</span> <span class="ident">CPtr</span> {
    <span class="kw">fn</span> <span class="ident">wrap</span>(<span class="ident">bits</span>: <span class="ident">CPtrBits</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::from_bits</span>(<span class="ident">bits</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">CapType</span><span class="op">&gt;</span> <span class="ident">WrappedCPtr</span> <span class="kw">for</span> <span class="ident">LocalCPtr</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">wrap</span>(<span class="ident">bits</span>: <span class="ident">CPtrBits</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::from_bits</span>(<span class="ident">bits</span>)
    }
}

<span class="kw">impl</span> <span class="ident">WrappedCPtr</span> <span class="kw">for</span> <span class="ident">LowLevelStaticThread</span> {
    <span class="kw">fn</span> <span class="ident">wrap</span>(<span class="ident">bits</span>: <span class="ident">CPtrBits</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::new</span>(<span class="ident">Endpoint::from_bits</span>(<span class="ident">bits</span>))
    }
}

<span class="kw">impl</span> <span class="ident">WrappedCPtr</span> <span class="kw">for</span> <span class="ident">StaticThread</span> {
    <span class="kw">fn</span> <span class="ident">wrap</span>(<span class="ident">bits</span>: <span class="ident">CPtrBits</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::from_endpoint</span>(<span class="ident">Endpoint::from_bits</span>(<span class="ident">bits</span>))
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">WrappedCPtr</span><span class="op">&gt;</span> <span class="ident">ConfigCPtr</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">T</span> {
        <span class="ident">T::wrap</span>(<span class="self">self</span>.<span class="ident">cptr</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_component_config_types" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>